import greenfoot.*;
import java.util.Random;
public class XRaceWorld extends World
{
    private int lineTime = 25;
    private int carTime = 25;
    private Random rnd = new Random();
    private int car = 0;
    private int carA = 0;
    private int carB = 0;
    private boolean rockTime = false;
    private boolean bananaTime = false;
    private Score score;
    private Car1 player;

    public Car1 getPlayer() {
        return player;
    }
    
    public XRaceWorld()
    {    
        super(400, 800, 1);
        this.setPaintOrder(Score.class, HitPoints.class, Car1.class, Car2.class, Rock.class, Banana.class, RoadLine.class);
        prepare();
    }

    private void prepare()
    {
        player = new Car1();
        addObject(player, 200, 650);
        score = new Score();
        addObject(score, 200, 25);
        HitPoints hp = new HitPoints();
        addObject(hp, 200, 775);
        addObject(new RoadLine(), 150, 250);
        addObject(new RoadLine(), 250, 250);
        addObject(new RoadLine(), 150, 500);
        addObject(new RoadLine(), 250, 500);
        addObject(new RoadLine(), 150, 750);
        addObject(new RoadLine(), 250, 750);

    }

    public void act()
    {
        if (lineTime==25)
        {
            this.addObject(new RoadLine(), 150, 0);
            this.addObject(new RoadLine(), 250, 0);
            lineTime=0;
        }
        lineTime++;

        if (carTime==25) 
        {
            car = rnd.nextInt(6);
            if (car-carA<2 && car-carA>-2 && carA-carB<2 && carA-carB>-2)
            {
                car=0;
            }

            if (car>=1 && car<=5) {
                this.addObject(new Car2(), 20+car*60, 0);
            }
            carTime=0;
            carB = carA;
            carA = car;            
        }
        carTime++;

        if (score.getScore()>1500) rockTime = true;

        if (rockTime) {
            if(rnd.nextInt(250)==1) {
                Rock r = new Rock();
                addObject(r, rnd.nextInt(260)+80, 0);
            }
        }
        
        if (score.getScore()>3000) bananaTime = true;

        if (bananaTime) {
            if(rnd.nextInt(500)==1) {
                Banana ban = new Banana();
                addObject(ban, rnd.nextInt(260)+80, 0);
            }
        }
    }
}
